#!/usr/bin/python

# ZADATAK 3
# Napisati skript koji je u stanju da uporedi odnosno upari dve datoteke. Izlaz iz programa se ispisuje
# na standardni izlaz, a predstavlja spisak svih linija i njihovih rednih brojeva koji se nalaze u prvoj, a
# ne u drugoj datoteci i obrnuto. Imati na umu da se linije iz prve i druge uparuju, pa ako se neka
# linija iz prve nalazi dva puta u drugoj, ne uparuje se i drugi put (i obrnuto). Npr. u nastavku su
# redom date ulazne datoteke dat1.txt, dat2.txt i izlazna datoteka diff.txt:

# citanje i unos fajlova
fajl1 = open("03_fajl1.txt", "r")
fajl2 = open("03_fajl2.txt", "r")
data1 = fajl1.readlines()
data2 = fajl2.readlines()
fajl1.close()
fajl2.close()

# Funkcija uklanja karakter za novi red ukoliko postoji
def removeNewLine(rec):
	if rec.endswith('\n'):
		rec = rec[0:len(rec)-1]
	return rec

# Uklanja sve nove redove unutar fajla
def removeNewLinesFromCollectionOfWords(data):
	for i in range(0,len(data)):
		data[i] = removeNewLine(data[i])
	return data

data1 = removeNewLinesFromCollectionOfWords(data1)
data2 = removeNewLinesFromCollectionOfWords(data2)

# koristimo mape da zapisemo brojeve linija za procitane fajlove
# NAPOMENA: Resenje moze biti efikasnije naravno, ovo je izabrano radi ilustracije i citljivosti
data1_numbers = dict.fromkeys(data1, 0)
data2_numbers = dict.fromkeys(data2, 0)
i = 1
for line in data1:
	data1_numbers[line] = i
	i += 1

i = 1
for line in data2:
	data2_numbers[line] = i
	i += 1

# kreiramo skupove od procitanih datoteka
# 1 element skupa je cela linija unutar datoteke
data1 = set(data1)
data2 = set(data2)

# Koristimo operator razlika da dobijemo trazene razlike unutar fajlova
data1_without_data2 = data1 - data2
data2_without_data1 = data2 - data1

# upis u diff.txt
log = open('diff.txt', 'w')
log.write("Prvi fajl bez drugog\n********************\n")
for data in data1_without_data2:
	log.write(str(data1_numbers[data]) + ": " + data + "\n")

log.write("\nDrugi fajl bez prvog\n********************\n")
for data in data2_without_data1:
	log.write(str(data2_numbers[data]) + ": " + data + "\n")

log.close()







